const mongoose = require('mongoose').set('debug', false);
const Schema = mongoose.Schema;

mongoose.Promise = global.Promise;
mongoose.level = "";

const tools = require('../tools/general');

const {ObjectID} = require('mongodb');

// Resolving error Unknown modifier: $pushAll
mongoose.plugin(schema => {
  schema.options.usePushEach = true;
});

const AdTypeSchema = new Schema({
  _id: {
    type: Number,
  },
  descr: {
    type: String,
  },
});

AdTypeSchema.pre('save', async function (next) {
  if (this.isNew) {
    const myrec = await AdType.findOne().limit(1).sort({_id:-1});
    if (!!myrec) {
      if (myrec._doc._id === 0)
        this._id = 1;
      else
        this._id = myrec._doc._id + 1;
    } else {
      this._id = 1;
    }
  }

  next();
});


AdTypeSchema.statics.findAllIdApp = async function(idapp) {
  const AdType = this;

  const query = [
    {$sort: {_id: 1}},
  ];

  return await AdType.aggregate(query).then((arrrec) => {
    return arrrec;
  });

};

AdTypeSchema.statics.getFieldsForSearch = function() {
  return [
    {field: 'descr', type: tools.FieldType.string}];
};

AdTypeSchema.statics.executeQueryTable = function(idapp, params) {
  params.fieldsearch = this.getFieldsForSearch();
  return tools.executeQueryTable(this, 0, params);
};

const AdType = mongoose.model('AdType', AdTypeSchema);

module.exports = {AdType};
